<script setup lang="ts">
import { ref } from 'vue'
import { useDateFormat } from "@vueuse/core"

import type { User } from '@/types/User';

const rules = {
  required: (value: any) => !!value || 'Required.',
  min: (v: string) => v.length >= 8 || 'Min 8 characters',
  emailMatch: () => (`The email and password you entered don't match`),
}
const show1 = ref(false)
const search = ref('')
const sortBy = ref([{ key: 'id', order: 'desc' }])
const headers = [
  {
    align: 'start',
    key: 'id',
    title: 'No.', value: 'id'
  },
  { key: 'fullName', title: 'Name', value: 'fullName' },
  { key: 'gender', title: 'Gender', value: 'gender' },
  { key: 'roles', title: 'Roles', value: (item: any | User) => item.roles.join(', ') },
  { key: 'date', title: 'Date', value: 'date' },
  { key: 'checkIN', title: 'CheckIn', value: 'checkIN' },
  { key: 'checkOUT', title: 'CheckOut', value: 'checkOUT' },
  { key: 'workTime', title: 'WorkTime(h)' },
]
const users = ref<User[]>([
  {
    id: 1,
    email: 'admin',
    password: 'Pass@Word123',
    fullName: 'Admin',
    gender: 'male',
    roles: ['admin', 'user'],
    workTime: 8,
    workRate: 30,
    date: "Jan/10/2024",
    checkIN: "08:00",
    checkOUT: "16:00",
    isCheckedIn: false,
    isCheckedOut: true,
  },
  {
    id: 2,
    email: 'user1',
    password: 'Pass@Word123',
    fullName: 'User1',
    gender: 'female',
    roles: ['user'],
    workTime: 8,
    workRate: 35,
    date: "Jan/11/2024",
    checkIN: "08:00",
    checkOUT: "16:00",
    isCheckedIn: false,
    isCheckedOut: true,
  },
  {
    id: 3,
    email: 'user2',
    password: 'Pass@Word123',
    fullName: 'User2',
    gender: 'male',
    roles: ['user'],
    workTime: 8,
    workRate: 25,
    date: "Jan/12/2024",
    checkIN: "08:00",
    checkOUT: "16:00",
    isCheckedIn: false,
    isCheckedOut: true,
  },
]);
const enteredEmail = ref('');
const enteredPassword = ref('');
const startTime = ref('');
const endTime = ref('');
let lastId = 4
const AlertIn = ref(false);
const AlertOut = ref(false);

const checkIn = () => {
  const user = users.value.find(
    (u) => u.email === enteredEmail.value && u.password === enteredPassword.value && !u.isCheckedIn && u.isCheckedOut
  );

  if (user) {
    console.log('Yes');
    const newUser = { ...user };
    AlertIn.value = false;
    users.value.push({
      id: lastId++,
      email: newUser.email,
      password: newUser.password,
      fullName: newUser.fullName,
      gender: newUser.gender,
      roles: newUser.roles,
      workTime: 0,
      workRate: newUser.workRate,
      date: useDateFormat(new Date(), 'MMM/DD/YYYY'),
      checkIN: useDateFormat(new Date(), 'HH:mm'),
      checkOUT: "",
      isCheckedIn: true,
      isCheckedOut: false,
    }); user.isCheckedIn = true;
    enteredEmail.value = '';
    enteredPassword.value = '';

  } else {
    console.log('No');
    AlertIn.value = true;
  }
};

const checkOut = () => {
  const user = users.value.find(
    (u) => u.email === enteredEmail.value && u.password === enteredPassword.value && u.isCheckedIn && !u.isCheckedOut
  );

  if (user) {
    console.log('CheckOut Yes');
    user.checkOUT = useDateFormat(new Date(), 'HH:mm');
    user.isCheckedIn = false;
    user.isCheckedOut = true;
    startTime.value = user.checkIN;
    endTime.value = user.checkOUT;
    AlertOut.value = false;
    enteredEmail.value = '';
    enteredPassword.value = '';

    const startDate = new Date();
    const endDate = new Date();

    const startHours = startTime.value.split(':');
    startDate.setHours(parseInt(startHours[0]), parseInt(startHours[1]), 0);

    const endHours = endTime.value.split(':');
    endDate.setHours(parseInt(endHours[0]), parseInt(endHours[1]), 0);

    const hoursDifference = Math.floor((endDate - startDate) / (1000 * 60 * 60));
    user.workTime = hoursDifference;
  } else {
    console.log('CheckOut No');
    AlertOut.value = true;
  }
};

</script>

<template>
<v-toolbar flat style="background-color: rgba(97, 63, 45, 0.867);">  
  <v-toolbar-title style="color: whitesmoke;">CheckIn - CheckOut</v-toolbar-title></v-toolbar>
   <v-form>
     <v-container fluid style="background-color: rgba(228, 212, 204, 0.867);">
       <v-row>
         <v-col
           cols="12"
           sm="6"
         >
         <v-text-field
          v-model="enteredEmail"
          :rules="[rules.required]"
          label="Email"
          variant="solo"
          hide-details="auto"
         ></v-text-field>
         </v-col>
 
         <v-col
           cols="12"
           sm="6"
         >
         <v-text-field
          v-model="enteredPassword"
          :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
          :rules="[rules.required, rules.min]"
          :type="show1 ? 'text' : 'password'"
          name="input-10-2"
          label="Password"
          variant="solo"
          hint="At least 8 characters"
          class="input-group--focused"
          @click:append="show1 = !show1"
         ></v-text-field>
         </v-col>
       </v-row>
       <v-row>
        <v-col sm="0"></v-col>
        <v-col>
          <v-btn @click="checkIn" block class="mt-2" style="color: rgb(0, 180, 0);">CheckIn</v-btn>
        </v-col>
        <v-col>
          <v-btn @click="checkOut" block class="mt-2" style="color: rgb(180, 0, 0);">CheckOut</v-btn>
        </v-col>
        <v-col></v-col>
       </v-row>
     </v-container>
     
     <v-container fluid style="background-color: rgba(228, 212, 204, 0.867);">
      <v-alert v-model="AlertIn" type="error" border="start"
      variant="tonal"
      closable
      title="Alert" @input="AlertIn = false">
        Already checked in! Please check out.
      </v-alert>
      <v-alert v-model="AlertOut" type="error" border="start"
      variant="tonal"
      closable
      title="Alert" @input="AlertOut = false">
        Please check in.
      </v-alert>
      <v-card
        flat
      >
      <template v-slot:text>
        <v-text-field
          v-model="search"
          label="Search"
          prepend-inner-icon="mdi-magnify"
          single-line
          variant="outlined"
          hide-details
        ></v-text-field>
      </template>

      <v-data-table
        v-model:sort-by="sortBy"
        :headers="headers"
        :items="users"
        :search="search"
      ></v-data-table>
      </v-card>
     </v-container>
   </v-form>
 </template>
